USE LF_RMOVMAG BY NUMREG CODART NRIG
JOIN LF_MOVMAG TO LF_RMOVMAG INTO NUMREG==NUMREG
JOIN %CAU TO 110 INTO CODTAB==CODCAUS
JOIN LF_ANAMAG TO LF_RMOVMAG INTO CODART==CODART 
JOIN LF_DOC TO LF_MOVMAG INTO PROVV==DOCPROVV ANNO==ANNODOC CODNUM==CODNUM NDOC==NUMDOC
JOIN %CAU TO 111 ALIAS 500 INTO CODTAB==CAUS

JOIN LF_UMART TO LF_RMOVMAG KEY 2 ALIAS 349 INTO CODART==CODART UM==UM
JOIN LF_UMART TO LF_ANAMAG  ALIAS 249 INTO CODART==CODART 
END
  
DESCRIPTION
BEGIN
    LF_ANAMAG->* "Anagrafica articoli"
    LF_MOVMAG->* "Movimenti di magazzino"
    LF_RMOVMAG->* "Righe Movimenti di magazzino"
    49->* "Unit di misura articoli"
    33->* "documenti"
END

GENERAL
BEGIN
    OFFSET 0 0
    FONT "Courier New"
    SIZE 12
    CARATTERE "X"
    INIZIALE 5 2
    FINALE 133
END

SECTION HEADER ODD 6

STRINGA 1 40 1
BEGIN
 KEY "nome ditta"
 PROMPT  1 1 "Ditta "
 MESSAGE _DITTA, !RAGSOC
END

STRINGA 2 10
BEGIN
 KEY "Data"
 PROMPT  104 1 "Data "
 MESSAGE _TODAY
END

NUMERO 3 7
BEGIN
 KEY "Nr. pagina"
 PROMPT  121 1 "Pagina "
 MESSAGE _PAGENO
END

NUMERO 4 25
BEGIN
 KEY "Intestazione stampa"
 PROMPT  45 2 "Stampa lista movimenti"
END

STRINGA 5 132
BEGIN
  KEY "Separatore (iniziale)"
  PROMPT 1 3 "------------------------------------------------------------------------------------------------------------------------------------------------------"
END

STRINGA 6
BEGIN
  KEY "numreg"
  PROMPT  3 4 "Num."
END

STRINGA 7 
BEGIN
  KEY "datacomp"
  PROMPT  10 4 "Data"
END

STRINGA 8
  BEGIN
  KEY "descr mov"
  PROMPT  20 4 "Descrizione movimento"
END

STRINGA 101 
BEGIN
  KEY ""
  PROMPT  2 5 "Cod.mag."
END

STRINGA 103 20
BEGIN
  KEY ""
  PROMPT  13 5 "Articolo"
END

STRINGA 104 40
BEGIN
  KEY ""
  PROMPT  35 5 "Descrizione articolo"
END

//STRINGA 105 
//BEGIN
//  KEY "caus"
//  PROMPT  74 5 "Causale"
//END

STRINGA 105 
BEGIN
  KEY "UMART"
  PROMPT  82 5 "UM"
END

NUMERO 106
BEGIN
  KEY "quant"
  PROMPT  88 5 "Quantita'"
END

NUMERO 107
BEGIN
  KEY "prezzo"
  PROMPT  109 5 "Prezzo"
END

NUMERO 108
BEGIN
  KEY "valore"
  PROMPT  120 5 "Valore"
END

STRINGA 100 132
BEGIN
  KEY "Separatore (iniziale)"
  PROMPT 1 6 "------------------------------------------------------------------------------------------------------------------------------------------------------"
END


END

SECTION BODY ODD 1
  SECTION HEADER_DATA 1 0 1 GROUP 
    DATA 1 
    BEGIN
      KEY "raggr fdata"
      PROMPT  1 1 "------------- Registrazioni del "
      FIELD LF_MOVMAG->DATACOMP
    END
  END
  SECTION RAGG_MOV 1 1 3 FILE LF_RMOVMAG GROUP LF_MOVMAG->DATACOMP

    NUMERO 1 
    BEGIN
      KEY "numreg"
      PROMPT  1 1 "Registrazione "
      FIELD LF_MOVMAG->NUMREG
      PICTURE "#####"
      MESSAGE RESET,10
    END

    DATA 2 8
    BEGIN
      KEY "datacomp"
      PROMPT  24 1 ""
      FIELD LF_MOVMAG->DATACOMP
    END
    STRINGA 3 40
      BEGIN
      KEY "descr mov"
      PROMPT  34 1 ""
      FIELD LF_MOVMAG->DESCR
    END
    STRINGA 4 24
      BEGIN
      KEY " CAUS mov"
      PROMPT  4 2 "Causale movimento "
      FIELD LF_MOVMAG->CODCAUS
    END
    STRINGA 5 50
    BEGIN
      KEY " DESCR CAUS"
      PROMPT  30 2 ""
      FIELD %CAU->S0
    END

    SECTION INFO_DOC 3 0 1 NUM_EXPR LF_MOVMAG->NUMDOC!=0
      STRINGA 6 20
      BEGIN
        KEY " NUMDOC"
        PROMPT  10 1 "Documento "
        FIELD LF_MOVMAG->NUMDOC
      END
      STRINGA 7 20
      BEGIN
        KEY " datadoc"
        PROMPT  30 1 "del "
        FIELD 33->DATADOC
      END
    END

    SECTION RIGHE_MOV 3 1 1 FILE LF_RMOVMAG GROUP NUMREG
      SECTION CAUS_RIGA 1 1 1 STREXPR LF_RMOVMAG->CAUS!=""
        STRINGA 4 24
          BEGIN
          KEY " CAUS mov"
          PROMPT  10 1 "Causale riga      "
          FIELD LF_RMOVMAG->CAUS
        END
        STRINGA 5 50
        BEGIN
          KEY " DESCR CAUS"
          PROMPT  34 1 ""
          FIELD 500@->S0
        END
      END

      STRINGA 101 3
      BEGIN
        KEY ""
        PROMPT  4 1 ""
        FIELD LF_RMOVMAG->CODMAG[1,3]
      END
      STRINGA 102 3
      BEGIN
        KEY ""
        PROMPT  8 1 ""
        FIELD LF_RMOVMAG->CODMAG[4,5]
      END

      STRINGA 103 20
      BEGIN
        KEY ""
        PROMPT  13 1 ""
        FIELD LF_RMOVMAG->CODART
      END

      STRINGA 104 40
      BEGIN
        KEY ""
        PROMPT  35 1 ""
        FIELD LF_ANAMAG->DESCR
      END

      //STRINGA 105 4
      //BEGIN
      //  KEY "CAUS"
      //  PROMPT  77 1 ""
      //  FIELD LF_RMOVMAG->CAUS
      //END

      STRINGA 105 20
      BEGIN
        KEY "UMART"
        PROMPT  82 1 ""
        FIELD LF_RMOVMAG->UM
      END

      NUMERO 106
      BEGIN
        KEY "quant"
        PROMPT  85 1 ""
        FIELD LF_RMOVMAG->QUANT
        PICTURE "####.###,@##"
      END

      NUMERO 107
      BEGIN
        KEY "prezzo"
        PROMPT  99 1 ""
        FIELD LF_RMOVMAG->PREZZO
        PICTURE "###.####.##@"
      END

      NUMERO 108
      BEGIN
        KEY "valore"
        PROMPT  112 1 ""
        MESSAGE _NUMEXPR,LF_RMOVMAG->PREZZO*LF_RMOVMAG->QUANT*349@->FC|ADD,10
        PICTURE "##.###.####.##@"
      END

    END // RIGHE MOVIMENTO

    NUMERO 10 
    BEGIN
      KEY "totale mov"
      PROMPT  83 3 "Totale valore movimentato:  "
      PICTURE "##.###.####.##@"
    END


 END
END // BODY SECTION
